-- 
-- 
-- 
--

-- what version of AD&D/D&D is this
coreVersion = "becmi";

-- this index points to the location of this save
-- in the aClericSaves, aFighterSaves, aMagicUserSaves,
-- aThiefSaves, aDwarfSaves, aElfSaves, aHalflingSaves
-- We do this so we can split the saves up and give
-- bonuses for things like just poison or just wands.
-- 1 = Death Ray or Poison
-- 2 = Magic Wands
-- 3 = Paralysis or Turn to Stone
-- 4 = Dragon Breath
-- 5 = Rod, Staff or Spell
saves_table_index = {
    ["poison"] = 1,
    ["paralyzation"] = 3,
    ["death"] = 1,
    ["rod"] = 5,
    ["staff"] = 5,
    ["wand"] = 2,
    ["petrification"] = 3,
    ["polymorph"] = 5,
    ["breath"] = 4,
    ["spell"] = 5
};

-- turn undead, cleric
aTurnUndead = {};

-- required for npcs, saving throws when used
aNPCSaves = {};

-- required for npcs, hit matrix when used
aMatrix = {};

function onInit()
  DataCommonADND.coreVersion = coreVersion;

  -- default initiative dice size 
	nDefaultInitiativeDice = 6;
  DataCommonADND.nDefaultInitiativeDice = nDefaultInitiativeDice;

  aDefaultSurpriseDice = {"d6"};
  DataCommonADND.aDefaultSurpriseDice = aDefaultSurpriseDice;

  -- default turn dice size 
  nDefaultTurnDice = {"d6", "d6"};
  DataCommonADND.nDefaultTurnDice = nDefaultTurnDice;
  nDefaultTurnUndeadMaxHD = 14; -- this is actually the number of turn_name_index entries
  DataCommonADND.nDefaultTurnUndeadMaxHD = nDefaultTurnUndeadMaxHD;
  -- index of the turns 1-14
  turn_name_index ={      -- make sure the HD listing is XXHD or X-XHD, 
      "Skeleton or 1HD",  -- we need the number it from of HD for the 
      "Zombie or 2HD",  -- turn undead automation.
      "Ghoul or 2HD",
      "Wight or 3HD",
      "Wraith or 4HD",
      "Mummy or 5HD+",
      "Spectre or 6HD",
      "Vampire or 7-9HD",
      "Phantom or 10-12HD",
      "Haunt or 12-14HD",
      "Spirit or 14-18HD",
      "Nightshade or 17-26HD",
      "Lich or 21-36HD",
      "Special 20HD"
  };
  DataCommonADND.turn_name_index = turn_name_index;
  -- cap of turn improvement
  nDefaultTurnUndeadMaxLevel = 36;
  DataCommonADND.nDefaultTurnUndeadMaxLevel = nDefaultTurnUndeadMaxLevel;

  --  0 = Cannot turn
  -- -1 = Turn
  -- -2 = Disentigrate
  -- -3 = Additional 1d6 creatures effected.
  -- -4 = Additional 2d6 creatures effected.
  aTurnUndead[1]  = { 7, 9,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  aTurnUndead[2]  = {-1, 7, 9,11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  aTurnUndead[3]  = {-1,-1, 7, 9,11, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  aTurnUndead[4]  = {-2,-1,-1, 7, 9,11, 0, 0, 0, 0, 0, 0, 0, 0};
  aTurnUndead[5]  = {-2,-2,-1,-1, 7, 9,11, 0, 0, 0, 0, 0, 0, 0};
  aTurnUndead[6]  = {-2,-2,-2,-1,-1, 7, 9,11, 0, 0, 0, 0, 0, 0};
  aTurnUndead[7]  = {-2,-2,-2,-2,-1,-1, 7, 9,11, 0, 0, 0, 0, 0};
  aTurnUndead[8]  = {-2,-2,-2,-2,-2,-1,-1, 7, 9,11, 0, 0, 0, 0};
  aTurnUndead[9]  = {-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11, 0, 0, 0};
  aTurnUndead[10] = {-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11, 0, 0, 0};
  aTurnUndead[11] = {-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11, 0, 0};
  aTurnUndead[12] = {-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11, 0, 0};
  aTurnUndead[13] = {-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11, 0};
  aTurnUndead[14] = {-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11, 0};
  aTurnUndead[15] = {-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11};
  aTurnUndead[16] = {-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9,11};
  aTurnUndead[17] = {-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9};
  aTurnUndead[18] = {-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9};
  aTurnUndead[19] = {-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9};
  aTurnUndead[20] = {-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7, 9};
  aTurnUndead[21] = {-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7};
  aTurnUndead[22] = {-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7};
  aTurnUndead[23] = {-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7};
  aTurnUndead[24] = {-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1, 7};
  aTurnUndead[25] = {-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[26] = {-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[27] = {-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[28] = {-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[29] = {-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[30] = {-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[31] = {-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[32] = {-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-2,-1,-1};
  aTurnUndead[33] = {-4,-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-1,-1};
  aTurnUndead[34] = {-4,-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-1,-1};
  aTurnUndead[35] = {-4,-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-1,-1};
  aTurnUndead[36] = {-4,-4,-4,-3,-3,-3,-3,-3,-2,-2,-2,-2,-1,-1};
  DataCommonADND.aTurnUndead = aTurnUndead;
  
  -------------------
  -- saving throws --
  -------------------
  -- Death, Wand, Paralysis, Breath, Spell
  -- Cleric
  aNPCSaves['C1']  = {11,12,14,16,15};
  aNPCSaves['C2']  = {11,12,14,16,15};
  aNPCSaves['C3']  = {11,12,14,16,15};
  aNPCSaves['C4']  = {11,12,14,16,15};
  aNPCSaves['C5']  = { 9,10,12,14,13};
  aNPCSaves['C6']  = { 9,10,12,14,13};
  aNPCSaves['C7']  = { 9,10,12,14,13};
  aNPCSaves['C8']  = { 9,10,12,14,13};
  aNPCSaves['C9']  = { 7, 8,10,12,11};
  aNPCSaves['C10'] = { 7, 8,10,12,11};
  aNPCSaves['C11'] = { 7, 8,10,12,11};
  aNPCSaves['C12'] = { 7, 8,10,12,11};
  aNPCSaves['C13'] = { 6, 7, 8,10, 9};
  aNPCSaves['C14'] = { 6, 7, 8,10, 9};
  aNPCSaves['C15'] = { 6, 7, 8,10, 9};
  aNPCSaves['C16'] = { 6, 7, 8,10, 9};
  aNPCSaves['C17'] = { 5, 6, 6, 8, 7};
  aNPCSaves['C18'] = { 5, 6, 6, 8, 7};
  aNPCSaves['C19'] = { 5, 6, 6, 8, 7};
  aNPCSaves['C20'] = { 5, 6, 6, 8, 7};
  aNPCSaves['C21'] = { 4, 5, 5, 6, 5};
  aNPCSaves['C22'] = { 4, 5, 5, 6, 5};
  aNPCSaves['C23'] = { 4, 5, 5, 6, 5};
  aNPCSaves['C24'] = { 4, 5, 5, 6, 5};
  aNPCSaves['C25'] = { 3, 4, 4, 4, 4};
  aNPCSaves['C26'] = { 3, 4, 4, 4, 4};
  aNPCSaves['C27'] = { 3, 4, 4, 4, 4};
  aNPCSaves['C28'] = { 3, 4, 4, 4, 4};
  aNPCSaves['C29'] = { 2, 3, 3, 3, 3};
  aNPCSaves['C30'] = { 2, 3, 3, 3, 3};
  aNPCSaves['C31'] = { 2, 3, 3, 3, 3};
  aNPCSaves['C32'] = { 2, 3, 3, 3, 3};
  aNPCSaves['C33'] = { 2, 2, 2, 2, 2};
  aNPCSaves['C34'] = { 2, 2, 2, 2, 2};
  aNPCSaves['C35'] = { 2, 2, 2, 2, 2};
  aNPCSaves['C36'] = { 2, 2, 2, 2, 2};
  -- Fighter
  -- NM == Normal Man
  aNPCSaves['NM']  = {14,15,16,17,17};
  aNPCSaves['F1']  = {12,13,14,15,16};
  aNPCSaves['F2']  = {12,13,14,15,16};
  aNPCSaves['F3']  = {12,13,14,15,16};
  aNPCSaves['F4']  = {10,11,12,13,14};
  aNPCSaves['F5']  = {10,11,12,13,14};
  aNPCSaves['F6']  = {10,11,12,13,14};
  aNPCSaves['F7']  = { 8, 9,10,11,12};
  aNPCSaves['F8']  = { 8, 9,10,11,12};
  aNPCSaves['F9']  = { 8, 9,10,11,12};
  aNPCSaves['F10'] = { 6, 7, 8, 9,10};
  aNPCSaves['F11'] = { 6, 7, 8, 9,10};
  aNPCSaves['F12'] = { 6, 7, 8, 9,10};
  aNPCSaves['F13'] = { 6, 6, 7, 8, 9};
  aNPCSaves['F14'] = { 6, 6, 7, 8, 9};
  aNPCSaves['F15'] = { 6, 6, 7, 8, 9};
  aNPCSaves['F16'] = { 5, 6, 6, 7, 8};
  aNPCSaves['F17'] = { 5, 6, 6, 7, 8};
  aNPCSaves['F18'] = { 5, 6, 6, 7, 8};
  aNPCSaves['F19'] = { 5, 5, 6, 6, 7};
  aNPCSaves['F20'] = { 5, 5, 6, 6, 7};
  aNPCSaves['F21'] = { 5, 5, 6, 6, 7};
  aNPCSaves['F22'] = { 4, 5, 5, 5, 6};
  aNPCSaves['F23'] = { 4, 5, 5, 5, 6};
  aNPCSaves['F24'] = { 4, 5, 5, 5, 6};
  aNPCSaves['F25'] = { 4, 4, 5, 4, 5};
  aNPCSaves['F26'] = { 4, 4, 5, 4, 5};
  aNPCSaves['F27'] = { 4, 4, 5, 4, 5};
  aNPCSaves['F28'] = { 3, 4, 4, 3, 4};
  aNPCSaves['F29'] = { 3, 4, 4, 3, 4};
  aNPCSaves['F30'] = { 3, 4, 4, 3, 4};
  aNPCSaves['F31'] = { 3, 3, 3, 3, 3};
  aNPCSaves['F32'] = { 3, 3, 3, 3, 3};
  aNPCSaves['F33'] = { 3, 3, 3, 3, 3};
  aNPCSaves['F34'] = { 2, 2, 2, 2, 2};
  aNPCSaves['F35'] = { 2, 2, 2, 2, 2};
  aNPCSaves['F36'] = { 2, 2, 2, 2, 2};
  -- Magic-user
  aNPCSaves['M1']  = {13,14,13,16,15};
  aNPCSaves['M2']  = {13,14,13,16,15};
  aNPCSaves['M3']  = {13,14,13,16,15};
  aNPCSaves['M4']  = {13,14,13,16,15};
  aNPCSaves['M5']  = {13,14,13,16,15};
  aNPCSaves['M6']  = {11,12,11,14,12};
  aNPCSaves['M7']  = {11,12,11,14,12};
  aNPCSaves['M8']  = {11,12,11,14,12};
  aNPCSaves['M9']  = {11,12,11,14,12};
  aNPCSaves['M10'] = {11,12,11,14,12};
  aNPCSaves['M11'] = { 9,10, 9,12, 9};
  aNPCSaves['M12'] = { 9,10, 9,12, 9};
  aNPCSaves['M13'] = { 9,10, 9,12, 9};
  aNPCSaves['M14'] = { 9,10, 9,12, 9};
  aNPCSaves['M15'] = { 9,10, 9,12, 9};
  aNPCSaves['M16'] = { 7, 8, 7,10, 6};
  aNPCSaves['M17'] = { 7, 8, 7,10, 6};
  aNPCSaves['M18'] = { 7, 8, 7,10, 6};
  aNPCSaves['M19'] = { 7, 8, 7,10, 6};
  aNPCSaves['M20'] = { 7, 8, 7,10, 6};
  aNPCSaves['M21'] = { 5, 6, 5, 8, 4};
  aNPCSaves['M22'] = { 5, 6, 5, 8, 4};
  aNPCSaves['M23'] = { 5, 6, 5, 8, 4};
  aNPCSaves['M24'] = { 5, 6, 5, 8, 4};
  aNPCSaves['M25'] = { 4, 4, 4, 6, 3};
  aNPCSaves['M26'] = { 4, 4, 4, 6, 3};
  aNPCSaves['M27'] = { 4, 4, 4, 6, 3};
  aNPCSaves['M28'] = { 4, 4, 4, 6, 3};
  aNPCSaves['M29'] = { 3, 3, 3, 4, 2};
  aNPCSaves['M30'] = { 3, 3, 3, 4, 2};
  aNPCSaves['M31'] = { 3, 3, 3, 4, 2};
  aNPCSaves['M32'] = { 3, 3, 3, 4, 2};
  aNPCSaves['M33'] = { 2, 2, 2, 2, 2};
  aNPCSaves['M34'] = { 2, 2, 2, 2, 2};
  aNPCSaves['M35'] = { 2, 2, 2, 2, 2};
  aNPCSaves['M36'] = { 2, 2, 2, 2, 2};
  -- Thief
  aNPCSaves['T1']  = {13,14,13,16,15};
  aNPCSaves['T2']  = {13,14,13,16,15};
  aNPCSaves['T3']  = {13,14,13,16,15};
  aNPCSaves['T4']  = {13,14,13,16,15};
  aNPCSaves['T5']  = {11,12,11,14,13};
  aNPCSaves['T6']  = {11,12,11,14,13};
  aNPCSaves['T7']  = {11,12,11,14,13};
  aNPCSaves['T8']  = {11,12,11,14,13};
  aNPCSaves['T9']  = { 9,10, 9,12,11};
  aNPCSaves['T10'] = { 9,10, 9,12,11};
  aNPCSaves['T11'] = { 9,10, 9,12,11};
  aNPCSaves['T12'] = { 9,10, 9,12,11};
  aNPCSaves['T13'] = { 7, 8, 7,10, 9};
  aNPCSaves['T14'] = { 7, 8, 7,10, 9};
  aNPCSaves['T15'] = { 7, 8, 7,10, 9};
  aNPCSaves['T16'] = { 7, 8, 7,10, 9};
  aNPCSaves['T17'] = { 5, 6, 6, 8, 7};
  aNPCSaves['T18'] = { 5, 6, 6, 8, 7};
  aNPCSaves['T19'] = { 5, 6, 6, 8, 7};
  aNPCSaves['T20'] = { 5, 6, 6, 8, 7};
  aNPCSaves['T21'] = { 4, 5, 4, 6, 5};
  aNPCSaves['T22'] = { 4, 5, 4, 6, 5};
  aNPCSaves['T23'] = { 4, 5, 4, 6, 5};
  aNPCSaves['T24'] = { 4, 5, 4, 6, 5};
  aNPCSaves['T25'] = { 3, 4, 3, 4, 4};
  aNPCSaves['T26'] = { 3, 4, 3, 4, 4};
  aNPCSaves['T27'] = { 3, 4, 3, 4, 4};
  aNPCSaves['T28'] = { 3, 4, 3, 4, 4};
  aNPCSaves['T29'] = { 2, 3, 2, 3, 3};
  aNPCSaves['T30'] = { 2, 3, 2, 3, 3};
  aNPCSaves['T31'] = { 2, 3, 2, 3, 3};
  aNPCSaves['T32'] = { 2, 3, 2, 3, 3};
  aNPCSaves['T33'] = { 2, 2, 2, 2, 2};
  aNPCSaves['T34'] = { 2, 2, 2, 2, 2};
  aNPCSaves['T35'] = { 2, 2, 2, 2, 2};
  aNPCSaves['T36'] = { 2, 2, 2, 2, 2};
  -- Dwarf
  aNPCSaves['D1']  = { 8, 9,10,13,12};
  aNPCSaves['D2']  = { 8, 9,10,13,12};
  aNPCSaves['D3']  = { 8, 9,10,13,12};
  aNPCSaves['D4']  = { 6, 7, 8,10, 9};
  aNPCSaves['D5']  = { 6, 7, 8,10, 9};
  aNPCSaves['D6']  = { 6, 7, 8,10, 9};
  aNPCSaves['D7']  = { 4, 5, 6, 7, 6};
  aNPCSaves['D8']  = { 4, 5, 6, 7, 6};
  aNPCSaves['D9']  = { 4, 5, 6, 7, 6};
  aNPCSaves['D10'] = { 2, 3, 4, 4, 3};
  aNPCSaves['D11'] = { 2, 3, 4, 4, 3};
  aNPCSaves['D12'] = { 2, 3, 4, 4, 3};
  -- Elf
  aNPCSaves['E1']  = {12,13,13,15,15};
  aNPCSaves['E2']  = {12,13,13,15,15};
  aNPCSaves['E3']  = {12,13,13,15,15};
  aNPCSaves['E4']  = { 8,10,10,11,11};
  aNPCSaves['E5']  = { 8,10,10,11,11};
  aNPCSaves['E6']  = { 8,10,10,11,11};
  aNPCSaves['E7']  = { 4, 7, 7, 7, 7};
  aNPCSaves['E8']  = { 4, 7, 7, 7, 7};
  aNPCSaves['E9']  = { 4, 7, 7, 7, 7};
  aNPCSaves['E10'] = { 2, 4, 4, 3, 3};
  -- Halfling
  aNPCSaves['H1']  = { 8, 9,10,13,12};
  aNPCSaves['H2']  = { 8, 9,10,13,12};
  aNPCSaves['H3']  = { 8, 9,10,13,12};
  aNPCSaves['H4']  = { 5, 6, 7, 9, 8};
  aNPCSaves['H5']  = { 5, 6, 7, 9, 8};
  aNPCSaves['H6']  = { 5, 6, 7, 9, 8};
  aNPCSaves['H7']  = { 2, 3, 4, 5, 4};
  aNPCSaves['H8']  = { 2, 3, 4, 5, 4};

  -------------------
  -- attack matrix --
  -------------------
  --                 19, 18, 17, 16, 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0, -1, -2, -3, -4, -5, -6, -7, -8, -9,-10,-11,-12,-13,-14,-15,-16,-17,-18,-19,-20 
  -- "Normal Man"
  aMatrix['0']   = {  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30, 30, 30, 31, 32};
  -- "Up to 1", MU 1-5, CTD 1-4, F 1-3
  aMatrix['1']   = {  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30, 30, 30, 31};
  -- "1+ to 2"
  aMatrix['1+']  = {  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30, 30, 30};
  aMatrix['2']   = {  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30, 30, 30};
  -- "2+ to 3", MU 6-10, CTD 5-8, F 4-6
  aMatrix['2+']  = {  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30, 30};
  aMatrix['3']   = {  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30, 30};
  -- "3+ to 4"
  aMatrix['3+']  = {  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30};
  aMatrix['4']   = {  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30};
  -- "4+ to 5", MU 11-15, CTD 9-12, F 7-9, DH A
  aMatrix['4+']  = {  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30};
  aMatrix['5']   = {  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30};
  -- "5+ to 6", DH B
  aMatrix['5+']  = { -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30};
  aMatrix['6']   = { -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30};
  -- "6+ to 7", MU 16-20, CTD 13-16, F 10-12, DH C
  aMatrix['6+']  = { -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29};
  aMatrix['7']   = { -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29};
  -- "7+ to 8", DH D
  aMatrix['7+']  = { -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28};
  aMatrix['8']   = { -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27, 28};
  -- "8+ to 9", MU 21-25, CTD 17-20, F 13-15, DH E
  aMatrix['8+']  = { -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27};
  aMatrix['9']   = { -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26, 27};
  -- "9+ to 11", DH F
  aMatrix['9+']  = { -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26};
  aMatrix['10']  = { -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26};
  aMatrix['10+'] = { -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26};
  aMatrix['11']  = { -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25, 26};
  -- "11+ to 13", MU 26-30, CTD 21-24, F 16-18, DH G
  aMatrix['11+'] = { -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25};
  aMatrix['12']  = { -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25};
  aMatrix['12+'] = { -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25};
  aMatrix['13']  = { -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24, 25};
  -- "13+ to 15", DH H
  aMatrix['13+'] = { -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24};
  aMatrix['14']  = { -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24};
  aMatrix['14+'] = { -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24};
  aMatrix['15']  = { -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23, 24};
  -- "15+ to 17", MU 31-35, CTD 25-28, F 19-21, DH I
  aMatrix['15+'] = { -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23};
  aMatrix['16']  = { -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23};
  aMatrix['16+'] = { -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23};
  aMatrix['17']  = { -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22, 23};
  -- "17+ to 19", DH J
  aMatrix['17+'] = { -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22};
  aMatrix['18']  = { -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22};
  aMatrix['18+'] = { -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22};
  aMatrix['19']  = { -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21, 22};
  -- "19+ to 21", MU 36, CTD 29-32, F 22-24, DH K
  aMatrix['19+'] = {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21};
  aMatrix['20']  = {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21};
  aMatrix['20+'] = {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21};
  aMatrix['21']  = {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20, 21};
  -- "21+ to 23", DH L
  aMatrix['21+'] = {-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20};
  aMatrix['22']  = {-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20};
  aMatrix['22+'] = {-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20};
  aMatrix['23']  = {-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20, 20};
  -- "23+ to 25", CTD 33-25, F 25-27, DH M
  aMatrix['23+'] = {-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20};
  aMatrix['24']  = {-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20};
  aMatrix['24+'] = {-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20};
  aMatrix['25']  = {-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20, 20};
  -- "25+ to 27"
  aMatrix['25+'] = {-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20};
  aMatrix['26']  = {-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20};
  aMatrix['26+'] = {-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20};
  aMatrix['27']  = {-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20, 20};
  -- "27+ to 29" CTD 36, F 28-30
  aMatrix['27+'] = {-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20};
  aMatrix['28']  = {-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20};
  aMatrix['28+'] = {-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20};
  aMatrix['29']  = {-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20};
  -- "29+ to 31"
  aMatrix['29+'] = {-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20};
  aMatrix['30']  = {-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20};
  aMatrix['30+'] = {-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20};
  aMatrix['31']  = {-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20};
  -- "31+ to 33", F 31-33
  aMatrix['31+'] = {-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19};
  aMatrix['32']  = {-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19};
  aMatrix['32+'] = {-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19};
  aMatrix['33']  = {-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19};
  -- "33+ to 35"
  aMatrix['33+'] = {-13,-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18};
  aMatrix['34']  = {-13,-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18};
  aMatrix['34+'] = {-13,-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18};
  aMatrix['35']  = {-13,-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18};
  -- "35+ and up", F 34-36
  aMatrix['35+'] = {-14,-13,-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17};
  aMatrix['36']  = {-14,-13,-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17};
  aMatrix['36+'] = {-14,-13,-12,-11,-10,-10,-10,-10,-10, -9, -8, -7, -6, -5, -4, -3, -2, -1,  0,  1,  2,  2,  2,  2,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17};

  DataCommonADND.aMatrix=aMatrix;

  DataCommonADND.saves_table_index=saves_table_index;
  DataCommonADND.aNPCSaves=aNPCSaves;
end
